package org.artifactory.metrics.framework.providers;

import org.artifactory.storage.service.StorageMetric;
import org.artifactory.storage.service.StorageMetricCollector;
import org.jfrog.metrics.model.Metric;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

import java.util.List;

import static org.mockito.Mockito.when;
import static org.testng.Assert.assertEquals;

public class StorageMetricProviderTest {

    @Mock
    private StorageMetricCollector storageMetricCollector;

    @BeforeClass
    public void beforeClass() {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void happyFlow() {
        when(storageMetricCollector.get()).thenReturn(new StorageMetric(5));
        StorageMetricProvider storageMetricProvider = new StorageMetricProvider(storageMetricCollector);
        List<Metric> metrics = storageMetricProvider.collect();
        assertEquals(metrics.size(), 1);
        Metric first = metrics.get(0);
        assertEquals(first.getValue().doubleValue(), 5.0d);
    }

}