package org.artifactory.ui.rest.service.admin.security.user.mfa;

import org.artifactory.api.security.SecurityService;
import org.artifactory.rest.common.service.ArtifactoryRestRequest;
import org.artifactory.rest.common.service.RestResponse;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

/**
 * @author Roman Kreichman
 */
@Test
public class ResetUserMFAStatusTest {
    @Mock
    ArtifactoryRestRequest requestMock;

    @Mock
    SecurityService securityService;

    @InjectMocks
    ResetUserMFAStatus resetUserMFAStatus;

    @BeforeMethod
    public void setUp() {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void testUsernameIsPassedToSecurityService() {
        when(requestMock.getPathParamByKey("userName")).thenReturn("the-username");
        resetUserMFAStatus.execute(requestMock, mock(RestResponse.class));
        // Just test that the username value is passed to SecurityService
        verify(securityService, times(1)).resetUserMfaStatus("the-username");
    }
}