package org.artifactory.rest.services.artifact.lifecycle;

import org.artifactory.addon.AddonsManager;
import org.artifactory.addon.artifact.lifecycle.ArtifactLifecycleAddon;
import org.artifactory.addon.artifact.lifecycle.ArtifactLifecyclePolicyModel;
import org.artifactory.rest.common.service.ArtifactoryRestRequest;
import org.artifactory.rest.common.service.RestResponse;
import org.artifactory.rest.common.service.RestService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/**
 * @author Omri Ziv
 */
@Component
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
public class GetArtifactLifecyclePolicyService implements RestService {

    @Autowired
    private AddonsManager addonsManager;

    @Override
    public void execute(ArtifactoryRestRequest request, RestResponse response) {
        String policyKey = request.getPathParamByKey("policyKey");
        ArtifactLifecycleAddon artifactLifecycleAddon = addonsManager.addonByType(ArtifactLifecycleAddon.class);
        ArtifactLifecyclePolicyModel policyModel = artifactLifecycleAddon
                .getPolicy(policyKey);
        response.iModel(policyModel);
    }
}
